import 'dart:io';

import 'package:android_id/android_id.dart';
import 'package:device_info_plus/device_info_plus.dart';

import '../../feedsdk.dart';

class ModelDeviceApp {
  static ModelDeviceApp? _modelDeviceApp;
  String device_name = "";
  String package_name = "";
  static String device_uuid = "dkfjdf-8458893434-dknfksdfk-49384";
  String app_name = "";
  String platform = "";
  final String _underscore = "_";

  ModelDeviceApp._();

  static Future<ModelDeviceApp?> getInstance() async {
    if (_modelDeviceApp == null) {
      _modelDeviceApp = ModelDeviceApp._();
      await _initPlatformState();
    }
    return _modelDeviceApp;
  }

  static _initPlatformState() async {
    var deviceInfo = DeviceInfoPlugin();
    if (Platform.isAndroid) {
      const _androidIdPlugin = AndroidId();
      final String? uuid = await _androidIdPlugin.getId();
      if (uuid != null && uuid.isNotEmpty) {
        device_uuid = uuid;
      }
    } else if (Platform.isIOS) {
      var iOSDeviceInfo = await deviceInfo.iosInfo;
      var uuid = iOSDeviceInfo.identifierForVendor;
      if (uuid != null && uuid.isNotEmpty) {
        device_uuid = uuid;
      }
    }
  }

  String getUUID() {
    return device_uuid +
        _underscore +
        FeedSDK.appName.replaceAll(" ", _underscore);
  }
}
