import 'dart:io';

class RegisterRequest {
  String agent = '';
  String endpoint = 'https://fcm.googleapis.com/fcm/send/';
  String fcmToken = '';
  String feedifyUser = '';
  String feedifyKey = '';
  String feedifyDomain = '';
  String browser = '';
  String deviceUuid = '';

  RegisterRequest(String fcmTok, String feedUser, String feedKey,
      String feedDomain, String uuid) {
    fcmToken = fcmTok;
    feedifyUser = feedUser;
    feedifyDomain = feedDomain;
    feedifyKey = feedKey;
    deviceUuid = uuid;
    browser = _getBrowser();
    agent = _getAgent();
  }

  toMap() {
    var map = {};
    map['agent'] = agent;
    map['endpoint'] = endpoint + fcmToken;
    map['registration_id'] = fcmToken;
    map['user_id'] = feedifyUser;
    map['domkey'] = feedifyKey;
    map['referrer'] = feedifyDomain;
    map['browser'] = browser;
    map['uuid'] = deviceUuid;
    return map;
  }

  @override
  String toString() {
    return 'agent :: $agent, endpoint :: $endpoint+$fcmToken, registration_id :: $fcmToken, '
        'user_id:: $feedifyUser , domkey:: $feedifyKey, referrer:: $feedifyDomain,browser ::$browser , uuid:: $deviceUuid ';
  }

  String _getBrowser() {
    return Platform.isAndroid ? 'Android Application' : 'iOS Application';
  }

  String _getAgent() {
    return Platform.isAndroid
        ? 'Feedify Flutter Android Application 1.0'
        : 'Feedify Flutter iOS Application 1.0';
  }
}
