import 'package:feedify/logs.dart';
import 'package:feedify/src/model/notification/model_local_notification.dart';
import 'package:feedify/src/utils/notification_util.dart';
import 'package:shared_preferences/shared_preferences.dart';

import '../model/notification/model_notification.dart';

class AppPreferences {
  static const String KEY_FCM = 'key_fcm';

  Future<SharedPreferences> _getPreferences() {
    return SharedPreferences.getInstance();
  }

  Future<bool> saveBool(String key, dynamic value) async {
    SharedPreferences sharedPreferences = await _getPreferences();
    bool result = await sharedPreferences.setBool(key, value);
    Logs.d('value saved $result :: $key => $value');
    return result;
  }

  Future<bool?> getBool(key) async {
    SharedPreferences sharedPreferences = await _getPreferences();
    return sharedPreferences.getBool(key);
  }

  Future<String?> getString(String key) async {
    SharedPreferences sharedPreferences = await _getPreferences();
    return sharedPreferences.getString(key);
  }

  Future<bool> saveString(String key, dynamic value) async {
    SharedPreferences sharedPreferences = await _getPreferences();
    bool result = await sharedPreferences.setString(key, value);
    Logs.d('value saved $result :: $key => $value');
    return result;
  }

  Future<void> savePayloadsInPreference(
      ModelNotification notificationData) async {
    Map<String, String> map = ModelLocalNotification.toMap(notificationData);
    map.forEach((key, value) {
      saveString(key, value ?? ''); // Convert null to an empty string
      NotificationUtils.notificationPayloadKeys.add(key);
    });
  }

  // Retrieve notification payloads data from shared preferences
  Future<Map<String, String?>> getNotificationsData() async {
    Map<String, String?> data = {};
    SharedPreferences sharedPreferences = await _getPreferences();
    for (String key in NotificationUtils.notificationPayloadKeys) {
      data[key] = sharedPreferences.getString(key);
    }
    return data;
  }
}
