import 'package:feedify/src/model/notification/model_local_notification.dart';
import 'package:feedify/src/model/notification/model_notification.dart';

class NotificationUtils {
  static final NotificationUtils _singleton = NotificationUtils._internal();

  NotificationUtils._internal();

  static NotificationUtils getInstance() {
    return _singleton;
  }

  Map<String, String> notificationData = {};
  static List<String> notificationPayloadKeys = [];

  NotificationUtils();

  Map<String, String>? getNotificationData(ModelNotification notificationData) {
    var data = ModelLocalNotification.toMap(notificationData);
    saveNotificationData(data);
    return data;
  }

  void saveNotificationData(Map<String, String> notificationMap) {
    notificationData.addAll(notificationMap);
  }

  Map<String, String> getSavedNotificationData() {
    return notificationData;
  }

  void clearNotificationData() {
    notificationData.clear();
  }
}
